﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private pnlBottom As B4XView
	Private Overlay As B4XView
	Private OverlayVisible As Boolean
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me, "B4XBottomSheet")
	
	Overlay = xui.CreatePanel("overlay")

	#If B4A
	Dim p As Panel = Overlay
	p.Elevation = 5dip
	#End If
	
	Root.AddView(Overlay, 0, 0, Root.Width, Root.Height)
	Overlay.LoadLayout("Overlay")
	
	pnlBottom.LoadLayout("Drawer")
	pnlBottom.SetColorAndBorder(xui.Color_White, 0, 0, 15dip)
	
	Overlay.Visible = False
	
End Sub

Sub ToggleDrawerState
	Dim Duration As Int = 100
	
	OverlayVisible = Not(OverlayVisible)
	Overlay.SetVisibleAnimated(Duration, OverlayVisible)
	
	Dim pnlBottomVisibleHeight As Int = pnlBottom.Height - 8dip 'hide bottom round corners
	
	If OverlayVisible Then
		SetActionBarColor(Colors.ARGB(150, 0, 0, 0))
		SetStatusBarColor( mixColors(Colors.ARGB(150, 0, 0, 0), Colors.black) )
		pnlBottom.SetLayoutAnimated(0, 0, pnlBottom.Parent.Height, pnlBottom.Width, pnlBottom.Height)
		pnlBottom.SetLayoutAnimated(Duration, 0, pnlBottom.Parent.Height - pnlBottomVisibleHeight, pnlBottom.Width, pnlBottom.Height)
	Else
		SetActionBarColor(Colors.Transparent)
		SetStatusBarColor(Colors.ARGB(150, 0, 0, 0))
		pnlBottom.SetLayoutAnimated(0, 0, pnlBottom.Parent.Height - pnlBottomVisibleHeight, pnlBottom.Width, pnlBottom.Height)
		pnlBottom.SetLayoutAnimated(Duration, 0, pnlBottom.Parent.Height, pnlBottom.Width, pnlBottom.Height)
	End If
End Sub

Sub SetStatusBarColor(Color As Int)
	'status
	Dim jo As JavaObject
	jo.InitializeContext
	Dim window As JavaObject = jo.RunMethodJO("getWindow", Null)
	window.RunMethod("addFlags", Array (0x80000000))
	window.RunMethod("clearFlags", Array (0x04000000))
	window.RunMethod("setStatusBarColor", Array(Color))
End Sub

Sub SetActionBarColor(Color As Int)
	'menu bar
	Dim jo As JavaObject
	jo.InitializeContext
	Dim cd As ColorDrawable
	cd.Initialize(Color, 0)
	jo.RunMethodJO("getActionBar", Null).RunMethod("setBackgroundDrawable", Array(cd))
End Sub

Sub mixColors(col1 As Int, col2 As Int) As Int
	Dim r1, g1, b1, r2, g2, b2, r3 ,g3, b3 As Int

	r1 = Bit.UnsignedShiftRight(Bit.And(col1, 0xff0000), 16)
	g1 = Bit.UnsignedShiftRight(Bit.And(col1, 0xff00), 8)
	b1 = Bit.And(col1, 0xff)

	r2 = Bit.UnsignedShiftRight(Bit.And(col2, 0xff0000), 16)
	g2 = Bit.UnsignedShiftRight(Bit.And(col2, 0xff00), 8)
	b2 = Bit.And(col2, 0xff)

	r3 = (r1 + r2)/2
	g3 = (g1 + g2)/2
	b3 = (b1 + b2)/2

	Return Colors.RGB(r3, g3, b3)
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub btn_Click
	ToggleDrawerState
End Sub

#If B4A
Private Sub Overlay_Click
#else
Private Sub Overlay_MouseClicked (EventData As MouseEvent)
#end If
	ToggleDrawerState
End Sub

